osl::container::MoveStack Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Types | Private Attributes | List of all members
osl::container::MoveStack Class Reference

Move のstack. More...

`#include <moveStack.h>`

Collaboration diagram for osl::container::MoveStack:
[legend]

## Public Member Functions
| MoveStack ()
| ~MoveStack ()
void | reserve (size_t)
void | clear ()
void | push (Move m)
void | pop ()
bool | hasLastMove (size_t last=1) const
const Move | lastMove (size_t last=1) const
size_t | size () const
void | dump (size_t last_n=0) const
void | dump (std::ostream &, size_t last_n=0) const
bool | operator== (const MoveStack &r) const

## Private Types
typedef vector< Move > | vector_t

## Private Attributes
vector_t | data

## Detailed Description

Move のstack.

主に探索で今までにさされた指手を保存するのに使用. size() == 0 の時に lastMove と lastMove(2) は Move::INVALID() を返す.

Definition at line 14 of file moveStack.h.

## Member Typedef Documentation

typedef vector<Move> osl::container::MoveStack::vector_t
| private

Definition at line 16 of file moveStack.h.

## Constructor & Destructor Documentation

osl::MoveStack::MoveStack | ( | ) |  |

Definition at line 5 of file moveStack.cc.

osl::MoveStack::~MoveStack | ( | ) |  |

Definition at line 11 of file moveStack.cc.

## Member Function Documentation

void osl::MoveStack::clear | ( | ) |  |

Definition at line 20 of file moveStack.cc.

void osl::container::MoveStack::dump | ( | size_t | last_n = `0`) |  | const

Parameters

  last_n | 最後のn個を表示，0なら全て．

void osl::container::MoveStack::dump | ( | std::ostream & | ,
|  | size_t | last_n = `0`
| ) |  | const

bool osl::container::MoveStack::hasLastMove | ( | size_t | last = `1`) |  | const
| inline

Parameters

  last | lastLastMove if 2

Definition at line 27 of file moveStack.h.

References size().

const Move osl::container::MoveStack::lastMove | ( | size_t | last = `1`) |  | const
| inline

Definition at line 28 of file moveStack.h.

References data.

Referenced by osl::search::MoveStackRejections::probe(), and osl::game_playing::SpeculativeSearchPlayer::selectBestMove().

bool osl::container::MoveStack::operator== | ( | const MoveStack & | r) |  | const
| inline

Definition at line 40 of file moveStack.h.

References data.

void osl::container::MoveStack::pop | ( | ) |  |
| inline

Definition at line 25 of file moveStack.h.

References data.

void osl::container::MoveStack::push | ( | Move | m) |  |
| inline

Definition at line 24 of file moveStack.h.

References data.

Referenced by osl::game_playing::HistoryToTable::adjustTable().

void osl::MoveStack::reserve | ( | size_t | capacity) |  |

Definition at line 15 of file moveStack.cc.

size_t osl::container::MoveStack::size | ( | ) |  | const
| inline

Definition at line 34 of file moveStack.h.

References data.

Referenced by hasLastMove(), osl::game_playing::SearchPlayer::saveSearchResult(), and osl::game_playing::SearchPlayer::secondsForThisMove().

## Member Data Documentation

vector_t osl::container::MoveStack::data
| private

Definition at line 17 of file moveStack.h.

Referenced by lastMove(), operator==(), pop(), push(), and size().

The documentation for this class was generated from the following files:

- moveStack.h
- moveStack.cc